'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var chunkXCXMKPPY_js = require('./chunk-XCXMKPPY.js');
var chunkKEKBFHDY_js = require('./chunk-KEKBFHDY.js');
var sprintfJs = require('sprintf-js');
var vue = require('vue');

function isGroup(data) {
  var _a;
  return typeof ((_a = data == null ? void 0 : data["@items"]) == null ? void 0 : _a.length) === "number";
}
function printfArgs(args) {
  var _a;
  if (args.length > 0 && typeof args[0] === "string") {
    const countParaments = (_a = args[0].match(/%\w/g)) == null ? void 0 : _a.length;
    if (countParaments) {
      const { length } = args;
      return [
        sprintfJs.sprintf(
          args[0],
          ...args.slice(1, countParaments + 1),
          ...length - 1 < countParaments ? Array(countParaments - (length - 1)).fill("%s") : []
        ),
        ...args.slice(countParaments + 1)
      ];
    }
  }
  return args;
}
var DataAPI = class {
  constructor(encoded, deepLocation = 0) {
    this.deepLocation = deepLocation;
    chunkKEKBFHDY_js.__publicField(this, "value", vue.shallowReactive(
      []
    ));
    chunkKEKBFHDY_js.__publicField(this, "queueGroups", []);
    chunkKEKBFHDY_js.__publicField(this, "counters", /* @__PURE__ */ new Map());
    chunkKEKBFHDY_js.__publicField(this, "timers", /* @__PURE__ */ new Map());
    chunkKEKBFHDY_js.__publicField(this, "encoded");
    this.encoded = encoded;
  }
  basicMethod(type, data) {
    const dataEncoded = this.encoded ? data : printfArgs(data).map((item) => chunkKEKBFHDY_js.Encode(item, this.deepLocation + 3));
    let lastItem;
    if (this.queueGroups.length > 0) {
      const lastGroup = this.queueGroups[this.queueGroups.length - 1];
      lastItem = lastGroup["@items"][lastGroup["@items"].length - 1];
    } else {
      lastItem = this.value[this.value.length - 1];
    }
    if (lastItem && !isGroup(lastItem) && lastItem.type === type && lastItem.data.length === dataEncoded.length && lastItem.data.every(
      (item, index) => item["@id"] === dataEncoded[index]["@id"]
    )) {
      lastItem.count++;
      return;
    }
    this.pushOfData({
      type,
      data: vue.readonly(dataEncoded),
      count: 1
    });
  }
  log(...data) {
    this.basicMethod("log", data);
  }
  warn(...data) {
    this.basicMethod("warn", data);
  }
  info(...data) {
    this.basicMethod("info", data);
  }
  debug(...data) {
    this.basicMethod("debug", data);
  }
  error(...data) {
    this.basicMethod("error", data);
  }
  table(data) {
    if (this.encoded) {
      if (chunkXCXMKPPY_js.isTable(data)) {
        this.pushOfData({
          type: "table",
          data: vue.readonly(data)
        });
        return;
      }
      this.log(data);
      return;
    }
    if (typeof data === "object") {
      this.pushOfData({
        type: "table",
        data: vue.readonly(
          chunkXCXMKPPY_js.Table(data, this.deepLocation + 2)
        )
      });
      return;
    }
    this.log(data);
  }
  pushOfData(data) {
    if (this.queueGroups.length > 0) {
      const currentGroup = this.queueGroups[this.queueGroups.length - 1];
      currentGroup["@items"].push(data);
      return;
    }
    this.value.push(data);
  }
  group(key = this.encoded ? chunkKEKBFHDY_js.Encode("console.group", this.deepLocation + 2) : "console.group") {
    const newGroup = {
      "@key": vue.readonly(
        this.encoded ? key : chunkKEKBFHDY_js.Encode(key, this.deepLocation + 2)
      ),
      "@items": vue.shallowReactive([])
    };
    this.pushOfData(newGroup);
    this.queueGroups.push(newGroup);
  }
  groupEnd(key = this.encoded ? chunkKEKBFHDY_js.Encode("console.group", this.deepLocation + 2) : "console.group") {
    const idKey = this.encoded ? key["@id"] : chunkKEKBFHDY_js.get(key);
    for (let i = this.queueGroups.length - 1; i >= 0; i--) {
      if (this.queueGroups[i]["@key"]["@id"] === idKey) {
        this.queueGroups.splice(i);
        break;
      }
    }
  }
  count(key = "default") {
    let count;
    if (count = this.counters.get(key + "")) {
      count++;
    } else {
      count = 1;
    }
    this.counters.set(key + "", count);
    const message = `${key}: ${count}`;
    this.log(
      this.encoded ? chunkKEKBFHDY_js.Encode(message, this.deepLocation + 2) : message
    );
  }
  countReset(key = "default") {
    this.counters.delete(key + "");
  }
  time(key = "default") {
    if (this.timers.has(key + "")) {
      const message = `Timer '${key}' already exists`;
      this.warn(
        this.encoded ? chunkKEKBFHDY_js.Encode(message, this.deepLocation + 2) : message
      );
      return;
    }
    this.timers.set(key + "", performance.now());
  }
  timeLog(key = "default") {
    const timer = this.timers.get(key + "");
    if (!timer) {
      const message2 = `Timer '${key}' does not exist`;
      this.warn(
        this.encoded ? chunkKEKBFHDY_js.Encode(message2, this.deepLocation + 2) : message2
      );
      return;
    }
    const message = `${key}: ${performance.now() - timer} ms`;
    this.log(
      this.encoded ? chunkKEKBFHDY_js.Encode(message, this.deepLocation + 2) : message
    );
  }
  timeEnd(key = "default") {
    this.timeLog(key);
    this.timers.delete(key + "");
  }
  clear() {
    this.value.splice(0);
    this.queueGroups.splice(0);
    this.counters.clear();
    this.timers.clear();
  }
};

exports.DataAPI = DataAPI;
exports.isGroup = isGroup;
exports.printfArgs = printfArgs;
