'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var chunkKEKBFHDY_js = require('./chunk-KEKBFHDY.js');

// src/logic/isArrayEmpty.ts
function isArrayEmpty({ arr }) {
  for (const name in arr) {
    if (Number.isNaN(+name))
      return true;
    return false;
  }
  return true;
}

// src/logic/Table.ts
function getExtendsPropertyDescriptors(data) {
  if (data === null || typeof data !== "object")
    return;
  if (chunkKEKBFHDY_js.isBuffer(data))
    return chunkKEKBFHDY_js.getOwnDescriptorsBuffer(data);
  if (chunkKEKBFHDY_js.isCollection(data))
    return chunkKEKBFHDY_js.getOwnDescriptorsCollection(data);
  if (chunkKEKBFHDY_js.isDataView(data))
    return chunkKEKBFHDY_js.getOwnDescriptorsDataView(data);
  if (chunkKEKBFHDY_js.isRegExp(data))
    return chunkKEKBFHDY_js.getOwnDescriptorsRegExp(data);
  if (chunkKEKBFHDY_js.isTypedArray(data))
    return chunkKEKBFHDY_js.getOwnDescriptorsTypedArray(data);
  return void 0;
}
function getDescriptors(data) {
  return Object.assign(
    chunkKEKBFHDY_js.getOwnDescriptorsIn(data),
    Object.getOwnPropertyDescriptors(data),
    getExtendsPropertyDescriptors(data)
  );
}
function Table(data, deepLink, noCollapse) {
  const table = {};
  const nameCols = /* @__PURE__ */ new Set();
  chunkKEKBFHDY_js.entries(getDescriptors(data)).forEach(([name, meta]) => {
    name = name.toString();
    const { value } = meta;
    let isArray;
    if (value !== null && typeof value === "object" && (!(isArray = Array.isArray(value)) || !isArrayEmpty({ arr: value }))) {
      const row = table[name] = {};
      chunkKEKBFHDY_js.entries(getDescriptors(value)).forEach(([propName, propMeta]) => {
        if (isArray && propName === "length")
          return;
        propName = propName.toString();
        nameCols.add(propName);
        row[propName] = chunkKEKBFHDY_js.createPreviewValue(propMeta.value);
      });
    } else {
      nameCols.add("Values");
      table[name] = {
        Values: chunkKEKBFHDY_js.createPreviewValue(value)
      };
    }
  });
  return {
    table,
    cols: Array.from(nameCols.values()),
    "@location": deepLink === false ? void 0 : chunkKEKBFHDY_js.getLocationCall(deepLink),
    "@collapse": noCollapse ? void 0 : chunkKEKBFHDY_js.Encode(data, false)
  };
}
function isTable(data) {
  return typeof (data == null ? void 0 : data.table) === "object";
}

exports.Table = Table;
exports.isTable = isTable;
